<template>
  <div v-if="users.length > 0" class="container">
    <transition name="fade" mode="out-in">
      <UserComponent
        key="user"
        :roles="roles"
        v-if="activeUser"
        :user="activeUser"
        :isChanges="isChanges"
        @closeUser="closeUser"
        @onHandleChange="onHandleChange"
      />
      <ListComponent
        v-else
        key="list"
        :users="users"
        :isEmpty="isEmpty"
        :isLoading="isLoading"
        :currentPage="currentPage"
        @loadMore="loadMore"
        @showUser="showUser"
      />
    </transition>
  </div>
  <div class="preloader" v-else>
    <div
      :key="i"
      v-for="i in 4"
      class="spinner-grow"
      style="width: 3rem; height: 3rem"
      role="status"
    >
      <span class="visually-hidden">Loading...</span>
    </div>
  </div>
</template>

<script>
import axios from "axios";
import ListComponent from "@/components/ListComponent.vue";
import UserComponent from "@/components/UserComponent.vue";

const route = "https://test-js.alef.dev";

export default {
  name: "App",
  data() {
    return {
      users: [],
      roles: [],
      isEmpty: false,
      currentPage: 0,
      isLoading: false,
      activeUser: null,
      isChanges: false,
    };
  },
  created() {
    axios
      .get(`${route}/users`)
      .then((res) => {
        this.users = res.data.data;
      })
      .catch((e) => {
        console.error(e);
      });

    axios
      .get(`${route}/roles`)
      .then((res) => {
        this.roles = res.data.data;
      })
      .catch((e) => {
        console.error(e);
      });
  },
  methods: {
    onHandleChange(e) {
      this.isChanges = true;

      if (this.activeUser.roles.length > e.length) {
        const role = this.activeUser.roles.find((role, i) => role !== e[i]);

        if (role) {
          const index = this.roles.findIndex((item) => item === role);

          axios
            .delete(`${route}/user/${this.activeUser.id}/role/${index + 1}`)
            .then((res) => {
              setTimeout(() => {
                this.isChanges = false;
              }, 500);
            })
            .catch((e) => {
              console.error(e);
            });
        }
      } else {
        const role = e.find((role, i) => !this.activeUser.roles[i]);

        if (role) {
          const index = this.roles.findIndex((item) => item === role);

          axios
            .post(`${route}/user/${this.activeUser.id}/role/${index + 1}`)
            .then((res) => {
              setTimeout(() => {
                this.isChanges = false;
              }, 500);
            })
            .catch((e) => {
              console.error(e);
            });
        }
      }

      return;
    },
    closeUser() {
      this.activeUser = null;
      return;
    },
    showUser(id) {
      axios
        .get(`${route}/user/${id}`)
        .then((res) => {
          setTimeout(() => {
            const user = res.data.data;
            user.id = id;

            if ("roles" in user) {
              const roles = user.roles.map((role) => this.roles[role - 1]);
              user.roles = roles;
            }

            this.activeUser = user;
          }, 500);
        })
        .catch((e) => {
          console.error(e);
        });

      return;
    },
    loadMore() {
      this.currentPage += 1;

      this.isLoading = true;

      axios
        .get(`${route}/users?page=${this.currentPage}`)
        .then((res) => {
          setTimeout(() => {
            this.isLoading = false;

            const data = res.data.data;

            if (Array.isArray(data) && data.length > 0) {
              this.users = this.users.concat(data);
            } else {
              this.isEmpty = true;
            }
          }, 1000);
        })
        .catch((e) => {
          console.error(e);
        });

      return;
    },
  },
  components: {
    ListComponent,
    UserComponent,
  },
};
</script>

<style>
#app {
  margin: 60px 0;
}
.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.3s ease;
}

.fade-enter-from,
.fade-leave-to {
  opacity: 0;
}
.preloader {
  width: 100%;
  height: 100%;
  display: flex;
  justify-content: center;
  align-items: center;
  position: fixed;
}
</style>
